diff --git a/inst/dist_fun/betacdf.m b/inst/dist_fun/betacdf.m
index a5a28d00..055a36e9 100644
--- a/inst/dist_fun/betacdf.m
+++ b/inst/dist_fun/betacdf.m
@@ -168,7 +168,7 @@ endfunction
 %!error<betacdf: function called with too few input arguments.> betacdf ()
 %!error<betacdf: function called with too few input arguments.> betacdf (1)
 %!error<betacdf: function called with too few input arguments.> betacdf (1, 2)
-%!error<betacdf: function called with too many inputs> betacdf (1, 2, 3, 4, 5)
+%!error<function called with too many inputs> betacdf (1, 2, 3, 4, 5)
 %!error<betacdf: invalid argument for upper tail.> betacdf (1, 2, 3, "tail")
 %!error<betacdf: invalid argument for upper tail.> betacdf (1, 2, 3, 4)
 %!error<betacdf: X, A, and B must be of common size or scalars.> ...
diff --git a/inst/dist_fun/betainv.m b/inst/dist_fun/betainv.m
index dc879188..2a9dceeb 100644
--- a/inst/dist_fun/betainv.m
+++ b/inst/dist_fun/betainv.m
@@ -153,7 +153,7 @@ endfunction
 %!error<betainv: function called with too few input arguments.> betainv ()
 %!error<betainv: function called with too few input arguments.> betainv (1)
 %!error<betainv: function called with too few input arguments.> betainv (1,2)
-%!error<betainv: function called with too many inputs> betainv (1,2,3,4)
+%!error<function called with too many inputs> betainv (1,2,3,4)
 %!error<betainv: P, A, and B must be of common size or scalars.> ...
 %! betainv (ones (3), ones (2), ones (2))
 %!error<betainv: P, A, and B must be of common size or scalars.> ...
diff --git a/inst/dist_fun/betapdf.m b/inst/dist_fun/betapdf.m
index b08e32b2..9af4b149 100644
--- a/inst/dist_fun/betapdf.m
+++ b/inst/dist_fun/betapdf.m
@@ -147,7 +147,7 @@ endfunction
 %!error<betapdf: function called with too few input arguments.> betapdf ()
 %!error<betapdf: function called with too few input arguments.> betapdf (1)
 %!error<betapdf: function called with too few input arguments.> betapdf (1,2)
-%!error<betapdf: function called with too many inputs> betapdf (1,2,3,4)
+%!error<function called with too many inputs> betapdf (1,2,3,4)
 %!error<betapdf: X, A, and B must be of common size or scalars.> ...
 %! betapdf (ones (3), ones (2), ones (2))
 %!error<betapdf: X, A, and B must be of common size or scalars.> ...
diff --git a/inst/dist_fun/binocdf.m b/inst/dist_fun/binocdf.m
index 9e4725e2..3151687b 100644
--- a/inst/dist_fun/binocdf.m
+++ b/inst/dist_fun/binocdf.m
@@ -144,7 +144,7 @@ endfunction
 %!error<binocdf: function called with too few input arguments.> binocdf ()
 %!error<binocdf: function called with too few input arguments.> binocdf (1)
 %!error<binocdf: function called with too few input arguments.> binocdf (1, 2)
-%!error<binocdf: function called with too many inputs> binocdf (1, 2, 3, 4, 5)
+%!error<function called with too many inputs> binocdf (1, 2, 3, 4, 5)
 %!error<binocdf: invalid argument for upper tail.> binocdf (1, 2, 3, "tail")
 %!error<binocdf: invalid argument for upper tail.> binocdf (1, 2, 3, 4)
 %!error<binocdf: X, N, and PS must be of common size or scalars.> ...
diff --git a/inst/dist_fun/binoinv.m b/inst/dist_fun/binoinv.m
index 64a719be..92674450 100644
--- a/inst/dist_fun/binoinv.m
+++ b/inst/dist_fun/binoinv.m
@@ -215,7 +215,7 @@ endfunction
 %!error<binoinv: function called with too few input arguments.> binoinv ()
 %!error<binoinv: function called with too few input arguments.> binoinv (1)
 %!error<binoinv: function called with too few input arguments.> binoinv (1,2)
-%!error<binoinv: function called with too many inputs> binoinv (1,2,3,4)
+%!error<function called with too many inputs> binoinv (1,2,3,4)
 %!error<binoinv: P, N, and PS must be of common size or scalars.> ...
 %! binoinv (ones (3), ones (2), ones (2))
 %!error<binoinv: P, N, and PS must be of common size or scalars.> ...
diff --git a/inst/dist_fun/binopdf.m b/inst/dist_fun/binopdf.m
index 2e0dcb57..618d3c60 100644
--- a/inst/dist_fun/binopdf.m
+++ b/inst/dist_fun/binopdf.m
@@ -286,7 +286,7 @@ endfunction
 %!error<binopdf: function called with too few input arguments.> binopdf ()
 %!error<binopdf: function called with too few input arguments.> binopdf (1)
 %!error<binopdf: function called with too few input arguments.> binopdf (1, 2)
-%!error<binopdf: function called with too many inputs> binopdf (1, 2, 3, 4)
+%!error<function called with too many inputs> binopdf (1, 2, 3, 4)
 %!error<binopdf: X, N, and PS must be of common size or scalars.> ...
 %! binopdf (ones (3), ones (2), ones (2))
 %!error<binopdf: X, N, and PS must be of common size or scalars.> ...
diff --git a/inst/dist_fun/bisacdf.m b/inst/dist_fun/bisacdf.m
index 8702f3b9..8a547135 100644
--- a/inst/dist_fun/bisacdf.m
+++ b/inst/dist_fun/bisacdf.m
@@ -163,7 +163,7 @@ endfunction
 %!error<bisacdf: function called with too few input arguments.> bisacdf ()
 %!error<bisacdf: function called with too few input arguments.> bisacdf (1)
 %!error<bisacdf: function called with too few input arguments.> bisacdf (1, 2)
-%!error<bisacdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! bisacdf (1, 2, 3, 4, 5)
 %!error<bisacdf: invalid argument for upper tail.> bisacdf (1, 2, 3, "tail")
 %!error<bisacdf: invalid argument for upper tail.> bisacdf (1, 2, 3, 4)
diff --git a/inst/dist_fun/bisainv.m b/inst/dist_fun/bisainv.m
index 083361da..c08218db 100644
--- a/inst/dist_fun/bisainv.m
+++ b/inst/dist_fun/bisainv.m
@@ -147,7 +147,7 @@ endfunction
 %!error<bisainv: function called with too few input arguments.> bisainv ()
 %!error<bisainv: function called with too few input arguments.> bisainv (1)
 %!error<bisainv: function called with too few input arguments.> bisainv (1, 2)
-%!error<bisainv: function called with too many inputs> bisainv (1, 2, 3, 4)
+%!error<function called with too many inputs> bisainv (1, 2, 3, 4)
 %!error<bisainv: P, BETA, and GAMMA must be of common size or scalars.> ...
 %! bisainv (ones (3), ones (2), ones(2))
 %!error<bisainv: P, BETA, and GAMMA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/bisapdf.m b/inst/dist_fun/bisapdf.m
index 339e2fa8..8a5e56bb 100644
--- a/inst/dist_fun/bisapdf.m
+++ b/inst/dist_fun/bisapdf.m
@@ -141,7 +141,7 @@ endfunction
 %!error<bisapdf: function called with too few input arguments.> bisapdf ()
 %!error<bisapdf: function called with too few input arguments.> bisapdf (1)
 %!error<bisapdf: function called with too few input arguments.> bisapdf (1, 2)
-%!error<bisapdf: function called with too many inputs> bisapdf (1, 2, 3, 4)
+%!error<function called with too many inputs> bisapdf (1, 2, 3, 4)
 %!error<bisapdf: X, BETA, and GAMMA must be of common size or scalars.> ...
 %! bisapdf (ones (3), ones (2), ones(2))
 %!error<bisapdf: X, BETA, and GAMMA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/burrcdf.m b/inst/dist_fun/burrcdf.m
index 7025adcc..85910c75 100644
--- a/inst/dist_fun/burrcdf.m
+++ b/inst/dist_fun/burrcdf.m
@@ -147,7 +147,7 @@ endfunction
 %!error<burrcdf: function called with too few input arguments.> burrcdf (1)
 %!error<burrcdf: function called with too few input arguments.> burrcdf (1, 2)
 %!error<burrcdf: function called with too few input arguments.> burrcdf (1, 2, 3)
-%!error<burrcdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! burrcdf (1, 2, 3, 4, 5, 6)
 %!error<burrcdf: invalid argument for upper tail.> burrcdf (1, 2, 3, 4, "tail")
 %!error<burrcdf: invalid argument for upper tail.> burrcdf (1, 2, 3, 4, 5)
diff --git a/inst/dist_fun/burrinv.m b/inst/dist_fun/burrinv.m
index 34fa2991..beb1d0da 100644
--- a/inst/dist_fun/burrinv.m
+++ b/inst/dist_fun/burrinv.m
@@ -126,7 +126,7 @@ endfunction
 %!error<burrinv: function called with too few input arguments.> burrinv (1)
 %!error<burrinv: function called with too few input arguments.> burrinv (1, 2)
 %!error<burrinv: function called with too few input arguments.> burrinv (1, 2, 3)
-%!error<burrinv: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! burrinv (1, 2, 3, 4, 5)
 %!error<burrinv: P, LAMBDA, C, and K must be of common size or scalars.> ...
 %! burrinv (ones (3), ones (2), ones(2), ones(2))
diff --git a/inst/dist_fun/burrpdf.m b/inst/dist_fun/burrpdf.m
index fd722a5e..759f174c 100644
--- a/inst/dist_fun/burrpdf.m
+++ b/inst/dist_fun/burrpdf.m
@@ -126,7 +126,7 @@ endfunction
 %!error<burrpdf: function called with too few input arguments.> burrpdf (1)
 %!error<burrpdf: function called with too few input arguments.> burrpdf (1, 2)
 %!error<burrpdf: function called with too few input arguments.> burrpdf (1, 2, 3)
-%!error<burrpdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! burrpdf (1, 2, 3, 4, 5)
 %!error<burrpdf: X, LAMBDA, C, and K must be of common size or scalars.> ...
 %! burrpdf (ones (3), ones (2), ones(2), ones(2))
diff --git a/inst/dist_fun/cauchycdf.m b/inst/dist_fun/cauchycdf.m
index 751a0f2b..1f96840f 100644
--- a/inst/dist_fun/cauchycdf.m
+++ b/inst/dist_fun/cauchycdf.m
@@ -137,7 +137,7 @@ endfunction
 %!error<cauchycdf: function called with too few input arguments.> cauchycdf (1)
 %!error<cauchycdf: function called with too few input arguments.> ...
 %! cauchycdf (1, 2)
-%!error<cauchycdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! cauchycdf (1, 2, 3, 4, 5)
 %!error<cauchycdf: invalid argument for upper tail.> cauchycdf (1, 2, 3, "tail")
 %!error<cauchycdf: invalid argument for upper tail.> cauchycdf (1, 2, 3, 4)
diff --git a/inst/dist_fun/cauchyinv.m b/inst/dist_fun/cauchyinv.m
index 6defd16f..7c391aba 100644
--- a/inst/dist_fun/cauchyinv.m
+++ b/inst/dist_fun/cauchyinv.m
@@ -123,7 +123,7 @@ endfunction
 %!error<cauchyinv: function called with too few input arguments.> cauchyinv (1)
 %!error<cauchyinv: function called with too few input arguments.> ...
 %! cauchyinv (1, 2)
-%!error<cauchyinv: function called with too many inputs> cauchyinv (1, 2, 3, 4)
+%!error<function called with too many inputs> cauchyinv (1, 2, 3, 4)
 %!error<cauchyinv: P, X0, and GAMMA must be of common size or scalars.> ...
 %! cauchyinv (ones (3), ones (2), ones(2))
 %!error<cauchyinv: P, X0, and GAMMA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/cauchypdf.m b/inst/dist_fun/cauchypdf.m
index 54106f48..316c9805 100644
--- a/inst/dist_fun/cauchypdf.m
+++ b/inst/dist_fun/cauchypdf.m
@@ -117,7 +117,7 @@ endfunction
 %!error<cauchypdf: function called with too few input arguments.> cauchypdf (1)
 %!error<cauchypdf: function called with too few input arguments.> ...
 %! cauchypdf (1, 2)
-%!error<cauchypdf: function called with too many inputs> cauchypdf (1, 2, 3, 4)
+%!error<function called with too many inputs> cauchypdf (1, 2, 3, 4)
 %!error<cauchypdf: X, X0, and GAMMA must be of common size or scalars.> ...
 %! cauchypdf (ones (3), ones (2), ones(2))
 %!error<cauchypdf: X, X0, and GAMMA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/chi2cdf.m b/inst/dist_fun/chi2cdf.m
index 25feaabc..3088341b 100644
--- a/inst/dist_fun/chi2cdf.m
+++ b/inst/dist_fun/chi2cdf.m
@@ -113,7 +113,7 @@ endfunction
 ## Test input validation
 %!error<chi2cdf: function called with too few input arguments.> chi2cdf ()
 %!error<chi2cdf: function called with too few input arguments.> chi2cdf (1)
-%!error<chi2cdf: function called with too many inputs> chi2cdf (1, 2, 3, 4)
+%!error<function called with too many inputs> chi2cdf (1, 2, 3, 4)
 %!error<chi2cdf: invalid argument for upper tail.> chi2cdf (1, 2, 3)
 %!error<chi2cdf: invalid argument for upper tail.> chi2cdf (1, 2, "uper")
 %!error<chi2cdf: X and DF must be of common size or scalars.> ...
diff --git a/inst/dist_fun/chi2inv.m b/inst/dist_fun/chi2inv.m
index 3c12e758..8398357d 100644
--- a/inst/dist_fun/chi2inv.m
+++ b/inst/dist_fun/chi2inv.m
@@ -92,7 +92,7 @@ endfunction
 ## Test input validation
 %!error<chi2inv: function called with too few input arguments.> chi2inv ()
 %!error<chi2inv: function called with too few input arguments.> chi2inv (1)
-%!error<chi2inv: function called with too many inputs> chi2inv (1,2,3)
+%!error<function called with too many inputs> chi2inv (1,2,3)
 %!error<chi2inv: P and DF must be of common size or scalars.> ...
 %! chi2inv (ones (3), ones (2))
 %!error<chi2inv: P and DF must be of common size or scalars.> ...
diff --git a/inst/dist_fun/chi2pdf.m b/inst/dist_fun/chi2pdf.m
index 1704c86a..35197745 100644
--- a/inst/dist_fun/chi2pdf.m
+++ b/inst/dist_fun/chi2pdf.m
@@ -93,7 +93,7 @@ endfunction
 ## Test input validation
 %!error<chi2pdf: function called with too few input arguments.> chi2pdf ()
 %!error<chi2pdf: function called with too few input arguments.> chi2pdf (1)
-%!error<chi2pdf: function called with too many inputs> chi2pdf (1,2,3)
+%!error<function called with too many inputs> chi2pdf (1,2,3)
 %!error<chi2pdf: X and DF must be of common size or scalars.> ...
 %! chi2pdf (ones (3), ones (2))
 %!error<chi2pdf: X and DF must be of common size or scalars.> ...
diff --git a/inst/dist_fun/exppdf.m b/inst/dist_fun/exppdf.m
index 493d0f80..7c263870 100644
--- a/inst/dist_fun/exppdf.m
+++ b/inst/dist_fun/exppdf.m
@@ -113,7 +113,7 @@ endfunction
 
 ## Test input validation
 %!error<exppdf: function called with too few input arguments.> exppdf ()
-%!error<exppdf: function called with too many inputs> exppdf (1,2,3)
+%!error<function called with too many inputs> exppdf (1,2,3)
 %!error<exppdf: X and MU must be of common size or scalars.> ...
 %! exppdf (ones (3), ones (2))
 %!error<exppdf: X and MU must be of common size or scalars.> ...
diff --git a/inst/dist_fun/gevcdf.m b/inst/dist_fun/gevcdf.m
index 623a6c8c..583452ab 100644
--- a/inst/dist_fun/gevcdf.m
+++ b/inst/dist_fun/gevcdf.m
@@ -187,7 +187,7 @@ endfunction
 %!error<gevcdf: function called with too few input arguments.> gevcdf (1)
 %!error<gevcdf: function called with too few input arguments.> gevcdf (1, 2)
 %!error<gevcdf: function called with too few input arguments.> gevcdf (1, 2, 3)
-%!error<gevcdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! gevcdf (1, 2, 3, 4, 5, 6)
 %!error<gevcdf: invalid argument for upper tail.> gevcdf (1, 2, 3, 4, "tail")
 %!error<gevcdf: invalid argument for upper tail.> gevcdf (1, 2, 3, 4, 5)
diff --git a/inst/dist_fun/laplacecdf.m b/inst/dist_fun/laplacecdf.m
index a64fc194..84cc10aa 100644
--- a/inst/dist_fun/laplacecdf.m
+++ b/inst/dist_fun/laplacecdf.m
@@ -135,7 +135,7 @@ endfunction
 %!error<laplacecdf: function called with too few input arguments.> laplacecdf (1)
 %!error<laplacecdf: function called with too few input arguments.> ...
 %! laplacecdf (1, 2)
-%!error<laplacecdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! laplacecdf (1, 2, 3, 4, 5)
 %!error<laplacecdf: invalid argument for upper tail.> laplacecdf (1, 2, 3, "tail")
 %!error<laplacecdf: invalid argument for upper tail.> laplacecdf (1, 2, 3, 4)
diff --git a/inst/dist_fun/laplaceinv.m b/inst/dist_fun/laplaceinv.m
index 3d2ac70c..bbf2aa74 100644
--- a/inst/dist_fun/laplaceinv.m
+++ b/inst/dist_fun/laplaceinv.m
@@ -107,7 +107,7 @@ endfunction
 %!error<laplaceinv: function called with too few input arguments.> laplaceinv (1)
 %!error<laplaceinv: function called with too few input arguments.> ...
 %! laplaceinv (1, 2)
-%!error<laplaceinv: function called with too many inputs> laplaceinv (1, 2, 3, 4)
+%!error<function called with too many inputs> laplaceinv (1, 2, 3, 4)
 %!error<laplaceinv: P, MU, and BETA must be of common size or scalars.> ...
 %! laplaceinv (1, ones (2), ones (3))
 %!error<laplaceinv: P, MU, and BETA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/laplacepdf.m b/inst/dist_fun/laplacepdf.m
index e7872882..71331278 100644
--- a/inst/dist_fun/laplacepdf.m
+++ b/inst/dist_fun/laplacepdf.m
@@ -111,7 +111,7 @@ endfunction
 %!error<laplacepdf: function called with too few input arguments.> laplacepdf (1)
 %!error<laplacepdf: function called with too few input arguments.> ...
 %! laplacepdf (1, 2)
-%!error<laplacepdf: function called with too many inputs> laplacepdf (1, 2, 3, 4)
+%!error<function called with too many inputs> laplacepdf (1, 2, 3, 4)
 %!error<laplacepdf: X, MU, and BETA must be of common size or scalars.> ...
 %! laplacepdf (1, ones (2), ones (3))
 %!error<laplacepdf: X, MU, and BETA must be of common size or scalars.> ...
diff --git a/inst/dist_fun/tricdf.m b/inst/dist_fun/tricdf.m
index 47ca582b..e144c859 100644
--- a/inst/dist_fun/tricdf.m
+++ b/inst/dist_fun/tricdf.m
@@ -153,7 +153,7 @@ endfunction
 %!error<tricdf: function called with too few input arguments.> tricdf (1)
 %!error<tricdf: function called with too few input arguments.> tricdf (1, 2)
 %!error<tricdf: function called with too few input arguments.> tricdf (1, 2, 3)
-%!error<tricdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! tricdf (1, 2, 3, 4, 5, 6)
 %!error<tricdf: invalid argument for upper tail.> tricdf (1, 2, 3, 4, "tail")
 %!error<tricdf: invalid argument for upper tail.> tricdf (1, 2, 3, 4, 5)
diff --git a/inst/dist_fun/triinv.m b/inst/dist_fun/triinv.m
index 0159988c..1b816bcd 100644
--- a/inst/dist_fun/triinv.m
+++ b/inst/dist_fun/triinv.m
@@ -125,7 +125,7 @@ endfunction
 %!error<triinv: function called with too few input arguments.> triinv (1)
 %!error<triinv: function called with too few input arguments.> triinv (1, 2)
 %!error<triinv: function called with too few input arguments.> triinv (1, 2, 3)
-%!error<triinv: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! triinv (1, 2, 3, 4, 5)
 %!error<triinv: P, A, B, and C must be of common size or scalars.> ...
 %! triinv (ones (3), ones (2), ones(2), ones(2))
diff --git a/inst/dist_fun/tripdf.m b/inst/dist_fun/tripdf.m
index 91be1e30..7922d469 100644
--- a/inst/dist_fun/tripdf.m
+++ b/inst/dist_fun/tripdf.m
@@ -122,7 +122,7 @@ endfunction
 %!error<tripdf: function called with too few input arguments.> tripdf (1)
 %!error<tripdf: function called with too few input arguments.> tripdf (1, 2)
 %!error<tripdf: function called with too few input arguments.> tripdf (1, 2, 3)
-%!error<tripdf: function called with too many inputs> ...
+%!error<function called with too many inputs> ...
 %! tripdf (1, 2, 3, 4, 5)
 %!error<tripdf: X, A, B, and C must be of common size or scalars.> ...
 %! tripdf (ones (3), ones (2), ones(2), ones(2))